//@author: antokhio
//@help: template for standard shaders
//@tags: template
//@credits: 

//StructuredBuffer<float4> color <bool color=true;>;

Texture2D tex0;
float2 R;
SamplerState s0:IMMUTABLE {Filter=MIN_MAG_MIP_POINT;AddressU=CLAMP;AddressV=CLAMP;};

struct VS_IN
{
	uint iv : SV_VertexID;
};

struct VS_OUT
{
    float4 pos: SV_POSITION;
    float col: TEXCOORD0;
};



VS_OUT VS(VS_IN input)
{
    VS_OUT output = (VS_OUT)0;
    output.pos  = float4 (0,0,0,1);
	float2 uv = 1/R; // pixles size
	int col = input.iv % R.x;
	int row = floor (input.iv / R.x);
	uv*= float2(col,row);
	
	output.col = tex0.SampleLevel(s0,uv,0).r;
	//output.col = col;
    return output;
}

float4 PS(VS_OUT input): SV_Target
{
	if (!input.col > 0)
    	discard;
	return input.col;
}

technique10 Template
{
	pass P0
	{
		SetVertexShader( CompileShader( vs_5_0, VS() ) );
		SetPixelShader( CompileShader( ps_5_0, PS() ) );
	}
}




